//+---------------------------------------------------------------------+
//|                                                      ColorJJRSX.mq5 | 
//|                                Copyright  2013,   Nikolay Kositsin | 
//|                                 Khabarovsk,   farria@mail.redcom.ru | 
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2013, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
#property description "Relative Strength Index"
//---   
#property version   "1.00"
//---     
#property indicator_separate_window
//---   
#property indicator_buffers 3 
//---   2  
#property indicator_plots   2
//+-----------------------------------+
//|     1 |
//+-----------------------------------+
//---     
#property indicator_type1   DRAW_LINE
//---      
#property indicator_color1 clrGray
//---   - 
#property indicator_style1  STYLE_SOLID
//---     1
#property indicator_width1  1
//---    
#property indicator_label1  "JJRSX"
//+-----------------------------------+
//|     2 |
//+-----------------------------------+
//---      
#property indicator_type2   DRAW_COLOR_HISTOGRAM
//---     
#property indicator_color2 clrRed,clrDarkOrange,clrGray,clrTeal,clrLime
//---   -  
#property indicator_style2  STYLE_SOLID
//---     3
#property indicator_width2  3
//---    
#property indicator_label2  "High Short;Short;Flat;Long;High Long"
//---     
#include <SmoothAlgorithms.mqh>
//+------------------------------------------+
//---    CJMA  CJurX   SmoothAlgorithms.mqh
CJJMA JMA;
CJurX UpJurX,DnJurX;
//+------------------------------------------+
//|                    |
//+------------------------------------------+
enum Applied_price_ // 
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simple Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_,  //TrendFollow_2 Price 
   PRICE_DEMARK_         //Demark Price
  };
//+------------------------------------------+
//|                    |
//+------------------------------------------+
enum IndStyle //   
  {
   COLOR_LINE = DRAW_COLOR_LINE,          // 
   COLOR_HISTOGRAM=DRAW_COLOR_HISTOGRAM,  // 
   COLOR_ARROW=DRAW_COLOR_ARROW           // 
  };
//+------------------------------------------+
//|                |
//+------------------------------------------+
input uint JurXPeriod=8;              //  JurX
input uint JMAPeriod=3;               //  JMA
input int JMAPhase=100;               //   JMA,
//--- JMAPhase: -100...+100,     ;
input Applied_price_ IPC=PRICE_CLOSE; //  
input int Shift=0;                    //      
input IndStyle Style=COLOR_HISTOGRAM; //   JJRSX
input int HighLevel=+20;              //   
input int MiddleLevel=0;              //  
input int LowLevel=-20;               //   
//+------------------------------------------+
//---   ,   
//---      
double JJRSX[];
double JJRSX_[];
double ColorJJRSX[];
//---      
int min_rates_total,min_rates_;
//+------------------------------------------------------------------+   
//| JJRSX indicator initialization function                          | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//---     
   min_rates_=2;
   min_rates_total=min_rates_+30;
//---      
   SetIndexBuffer(0,JJRSX_,INDICATOR_DATA);
//---      
   SetIndexBuffer(1,JJRSX,INDICATOR_DATA);
//---     ,     
   SetIndexBuffer(2,ColorJJRSX,INDICATOR_COLOR_INDEX);
//---    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---    1  
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---       
   PlotIndexSetInteger(1,PLOT_DRAW_TYPE,Style);
//---      
   string shortname;
   StringConcatenate(shortname,"Relative Strenght Index(",
                     string(JurXPeriod),",",string(JMAPeriod),",",string(JMAPhase),",",EnumToString(IPC),",",Shift,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//---     3   
   IndicatorSetInteger(INDICATOR_LEVELS,3);
//---       
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,HighLevel);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,MiddleLevel);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,2,LowLevel);
//---             
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,0,clrPurple);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,1,clrGray);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,2,clrPurple);
//---       -  
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,0,STYLE_DASHDOTDOT);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,1,STYLE_DASHDOTDOT);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,2,STYLE_DASHDOTDOT);
//---  
  }
//+------------------------------------------------------------------+ 
//| JJRSX iteration function                                         | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<min_rates_total) return(0);
//---       
   double dPrice,AbsdPrice,jrsx,uprsx,dnrsx;
//---        
   int first,clr;
//---    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=1; //      
     }
   else
     {
      first=prev_calculated-1; //      
     }
//---    
   for(int bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      //---   PriceSeries     price_
      dPrice=PriceSeries(IPC,bar,open,low,high,close)-PriceSeries(IPC,bar-1,open,low,high,close);
      AbsdPrice=MathAbs(dPrice);
      //---    !
      if(!AbsdPrice) AbsdPrice=_Point;
      //---      
      JJRSX[bar]=EMPTY_VALUE;
      //---    JurXSeries 
      uprsx=UpJurX.JurXSeries(1,prev_calculated,rates_total,0,JurXPeriod,dPrice,bar,false);
      dnrsx=DnJurX.JurXSeries(1,prev_calculated,rates_total,0,JurXPeriod,AbsdPrice,bar,false);
      jrsx=100*uprsx/dnrsx;
      //---    JMASeries 
      JJRSX[bar]=JMA.JJMASeries(min_rates_,prev_calculated,rates_total,0,JMAPhase,JMAPeriod,jrsx,bar,false);
      JJRSX_[bar]=JJRSX[bar];
      //---
      clr=2;
      if(JJRSX[bar]>JJRSX[bar-1]) {if(JJRSX[bar]>HighLevel) clr=4; else clr=3;}
      if(JJRSX[bar]<JJRSX[bar-1]) {if(JJRSX[bar]<LowLevel)  clr=0; else clr=1;}
      ColorJJRSX[bar]=clr;
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
